/******************************************************************************
 *            echecs_gestion_fichier_pgn.c                                    *
 *                                                                            *
 *  Copyright  2006  gerald.dumas                                             *
 *  linechec@laposte.net                                                      *
 ******************************************************************************
 *                                                                            *
 *  This program is free software; you can redistribute it and/or modify      *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  any later version.                                                        *
 *                                                                            *
 *  This program is distributed in the hope that it will be useful,           *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with this program; if not, write to the Free Software               *
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.*
 ******************************************************************************/

/*	Fonction de chargement d'une position de jeu en fonction
	d'une liste de coup généré par le site www.echecs.com	*/

#include "echecs_gestion_fichier_pgn.h"

// Fonction pour reduire le code ( boucle répétitive )
// Si la fonction ne trouve pas la piece recherchée, elle renvoie
// un objet piece_ajouer.type = -1.
type_piece
recherche_coup_valide (GList * liste_coups_jouables, gint couleur,
		       gchar * coup, gint coup_arrive)
{
  type_piece piece_a_jouer;
  GList *liste = NULL;
  register short int x, y, z;
  short int deb_compte;
  short int fin_compte;

  piece_a_jouer.type = -1;
  piece_a_jouer.couleur=0;
  piece_a_jouer.ponderation=0;
  piece_a_jouer.place=0;
  piece_a_jouer.nbre_cases_jouables=0;
  piece_a_jouer.deplacement_initial=0;

  short int case_depart = vide;
  short int piece_jouee = vide;

  // Détermination du type de pièce à jouer
  if (strncmp (coup, "N", 1) == 0)
    piece_jouee = cavalier;
  else if (strncmp (coup, "B", 1) == 0)
    piece_jouee = fou;
  else if (strncmp (coup, "K", 1) == 0)
    piece_jouee = roi;
  else if (strncmp (coup, "R", 1) == 0)
    piece_jouee = tour;
  else if (strncmp (coup, "Q", 1) == 0)
    piece_jouee = dame;
  else
    piece_jouee = pion;

  if (strlen (coup) == 1 && piece_jouee == pion)
    {
      // Determination de la case de départ
      if (strncmp (coup, "a", 1) == 0)
	case_depart = 26;
      else if (strncmp (coup, "b", 1) == 0)
	case_depart = 27;
      else if (strncmp (coup, "c", 1) == 0)
	case_depart = 28;
      else if (strncmp (coup, "d", 1) == 0)
	case_depart = 29;
      else if (strncmp (coup, "e", 1) == 0)
	case_depart = 30;
      else if (strncmp (coup, "f", 1) == 0)
	case_depart = 31;
      else if (strncmp (coup, "g", 1) == 0)
	case_depart = 32;
      else
	case_depart = 33;

      for (x = case_depart; x < case_depart + 96; x = x + 12)
	{
	  if (echiquier[x].type_piece == piece_jouee
	      && echiquier[x].couleur_piece == humain_joue)
	    {
	      // On vient de trouver un pion dans la colonne choisie.
	      // Maintenant il faut voir si ce pion peut jouer le coup arrivé.
	      liste = g_list_first (liste_coups_jouables);
	      y = g_list_length (liste);
	      if (y > 0)
		{
		  for (z = 0; z < y; z++)
		    {
		      if (((struct struct_coups_jouables *) (liste->data))->
			  pos_piece_tab == echiquier[x].pos_table_piece
			  &&
			  ((struct struct_coups_jouables *) (liste->data))->
			  coup == coup_arrive)
			{
			  piece_a_jouer =
			    table_piece[echiquier[x].pos_table_piece];
			  x = case_depart + 96;	// Pour sortir
			  z = y;
			}
		      liste = g_list_next (liste);
		    }
		}
	    }
	}
    }
  else if (strlen (coup) == 1 && piece_jouee != pion)
    {
      if (couleur == noire)
	{
	  deb_compte = 17;
	  fin_compte = 33;
	}
      else
	{
	  deb_compte = 1;
	  fin_compte = 17;
	}

      for (x = deb_compte; x < fin_compte; x++)
	{
	  if (table_piece[x].type == piece_jouee)
	    {
	      // On a trouvé une pièce de même type.
	      // Maintenant il faut chercher si cette pièce peut jouer la case
				// d'arrivée.
	      liste = g_list_first (liste_coups_jouables);
	      y = g_list_length (liste);
	      if (y > 0)
		{
		  for (z = 0; z < y; z++)
		    {
		      if (((struct struct_coups_jouables *) (liste->data))->
			  pos_piece_tab == x
			  &&
			  ((struct struct_coups_jouables *) (liste->data))->
			  coup == coup_arrive)
			{
			  piece_a_jouer = table_piece[x];
			  x = fin_compte;	// Pour sortir
			  z = y;
			}
		      liste = g_list_next (liste);
		    }
		}
	    }
	}
    }
  else if (strlen (coup) == 2)
    {
      coup = coup + 1;		// On se place sur la lettre de départ de la pièce
      // Determination de la case de départ
      if (strncmp (coup, "a", 1) == 0
	  || strncmp (coup, "b", 1) == 0
	  || strncmp (coup, "c", 1) == 0
	  || strncmp (coup, "d", 1) == 0
	  || strncmp (coup, "e", 1) == 0
	  || strncmp (coup, "f", 1) == 0
	  || strncmp (coup, "g", 1) == 0 || strncmp (coup, "h", 1) == 0)
	{
	  if (strncmp (coup, "a", 1) == 0)
	    case_depart = 26;
	  else if (strncmp (coup, "b", 1) == 0)
	    case_depart = 27;
	  else if (strncmp (coup, "c", 1) == 0)
	    case_depart = 28;
	  else if (strncmp (coup, "d", 1) == 0)
	    case_depart = 29;
	  else if (strncmp (coup, "e", 1) == 0)
	    case_depart = 30;
	  else if (strncmp (coup, "f", 1) == 0)
	    case_depart = 31;
	  else if (strncmp (coup, "g", 1) == 0)
	    case_depart = 32;
	  else
	    case_depart = 33;

	  for (x = case_depart; x < case_depart + 96; x = x + 12)
	    {
	      if (echiquier[x].type_piece == piece_jouee
		  && echiquier[x].couleur_piece == humain_joue)
		{
		  // On vient de trouver un pièce de même type dans la colonne incriminée.
		  // Maintenant il faut voir si cette pièce peut jouer le coup arrivé.
		  liste = g_list_first (liste_coups_jouables);
		  y = g_list_length (liste);
		  if (y > 0)
		    {
		      for (z = 0; z < y; z++)
			{
			  if (((struct struct_coups_jouables *) (liste->
								 data))->
			      pos_piece_tab == echiquier[x].pos_table_piece
			      &&
			      ((struct struct_coups_jouables *) (liste->
								 data))->
			      coup == coup_arrive)
			    {
			      piece_a_jouer =
				table_piece[echiquier[x].pos_table_piece];
			      x = case_depart + 96;	// Pour sortir de la 1ere boucle
			      z = y;
			    }
			  liste = g_list_next (liste);
			}
		    }
		}
	    }
	}
      else
	if (strncmp (coup, "1", 1) == 0
	    || strncmp (coup, "2", 1) == 0
	    || strncmp (coup, "3", 1) == 0
	    || strncmp (coup, "4", 1) == 0
	    || strncmp (coup, "5", 1) == 0
	    || strncmp (coup, "6", 1) == 0
	    || strncmp (coup, "7", 1) == 0 || strncmp (coup, "8", 1) == 0)
	{
	  if (strncmp (coup, "1", 1) == 0)
	    case_depart = 26;
	  else if (strncmp (coup, "2", 1) == 0)
	    case_depart = 38;
	  else if (strncmp (coup, "3", 1) == 0)
	    case_depart = 50;
	  else if (strncmp (coup, "4", 1) == 0)
	    case_depart = 62;
	  else if (strncmp (coup, "5", 1) == 0)
	    case_depart = 74;
	  else if (strncmp (coup, "6", 1) == 0)
	    case_depart = 86;
	  else if (strncmp (coup, "7", 1) == 0)
	    case_depart = 98;
	  else
	    case_depart = 110;

	  for (x = case_depart; x < case_depart + 8; x++)
	    {
	      if (echiquier[x].type_piece == piece_jouee
		  && echiquier[x].couleur_piece == humain_joue)
		{
		  // On vient de trouver un pièce de même type dans la colonne incriminée.
		  // Maintenant il faut voir si cette pièce peut jouer le coup arrivé.
		  liste = g_list_first (liste_coups_jouables);
		  y = g_list_length (liste);
		  if (y > 0)
		    {
		      for (z = 0; z < y; z++)
			{
			  if (((struct struct_coups_jouables *) (liste->
								 data))->
			      pos_piece_tab == echiquier[x].pos_table_piece
			      &&
			      ((struct struct_coups_jouables *) (liste->
								 data))->
			      coup == coup_arrive)
			    {
			      piece_a_jouer =
				table_piece[echiquier[x].pos_table_piece];
			      x = case_depart + 8;	// Pour sortir de la 1ere boucle
			    }
			  liste = g_list_next (liste);
			}
		    }
		}
	    }
	}
    }

  return piece_a_jouer;
}

// -----------------------------------------------------------------------------

void enregistrement_fichier_pgn (gchar * nom_fichier)
{
  register gint x, y, z;
  FILE *Fichier = NULL;
  gchar *filename = NULL;
	GtkWidget *menu_enregistrer;
	menu_enregistrer=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "menu enregistrer"));
	GtkWidget *barre_outils;
	barre_outils=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "barre outils"));

  // Vérification si le fichier porte bien l'extension .pgn. Dans le cas
	// contraire .pgn est ajouté.
  if (strstr (nom_fichier, ".pgn") == NULL)
    filename = g_strdup_printf ("%s.pgn", nom_fichier);
  else
    filename = g_strdup (nom_fichier);

  Fichier = fopen (filename, "w");
  if (Fichier != NULL)
	{
		fprintf (Fichier, "[Event \"Linechec\"]\n");
		fprintf (Fichier, "[Site \"http://linechec.sourceforge.net\"]\n");
		fprintf (Fichier, "[White \"White\"]\n");
		fprintf (Fichier, "[Black \"Black\"]\n\n");

		y = 0;
		z = 1;
		for (x = 1; x < num_coup_joue; x++)
		{
			fprintf (Fichier, "%d. ", z);
			fprintf (Fichier, "%s ", tab_sauve_partie[x].coup);
			y = y + strlen (tab_sauve_partie[x].coup) + 4;
			if (x < num_coup_joue - 1)
				{
					fprintf (Fichier, "%s ", tab_sauve_partie[x + 1].coup);
					y = y + strlen (tab_sauve_partie[x + 1].coup) + 1;
					x++;
				}
			z++;
			if (y > 70)
				{
					y = 0;
					fprintf (Fichier, "\n");
				}
		}
		fprintf (Fichier, "\n");
		fclose (Fichier);
		partie_en_cours = TRUE;
		partie_enregistree = TRUE;
		gtk_widget_set_sensitive (menu_enregistrer, FALSE);
		gtk_widget_set_sensitive (GTK_WIDGET(gtk_toolbar_get_nth_item
																		(GTK_TOOLBAR (barre_outils), 3)), FALSE);
	}
  g_free (filename);
}

gchar **
extraction_coup_dans_fichier (gchar * ligne_tmp1)
{
  gchar *ligne_tmp2 = NULL;
  gchar *memo_coup = NULL;
  gchar *Ligne = NULL;
  struct struct_coup *texte_coup = NULL;
  gchar *debut_commentaire = NULL;
  gchar *nouvelle_ligne = NULL;
  gchar *memo_coup_tmp = NULL;
  gchar **champs;
	gint x;

  if (strstr (ligne_tmp1, "[FEN"))
    {
      g_free (ligne_tmp1);
      return NULL;		// Si le fichier est un fichier de description d'une position alors on sort
    }

  memo_coup = g_strdup_printf (" ");

  // ligne_tmp1 contient tout le fichier pgn.
  // On va maintenant le découper ligne par ligne pour les traîter.
  ligne_tmp2 = ligne_tmp1;
  while (ligne_tmp2 < ligne_tmp1 + strlen (ligne_tmp1))	// Tant que ce n'est pas la fin
    {
      Ligne = g_strndup (ligne_tmp2, strstr (ligne_tmp2, "\n") - ligne_tmp2);
      ligne_tmp2 = ligne_tmp2 + strlen (Ligne) + 1;

      // Suppression des espaces au début de la ligne (s'ils existent)
      // et à la fin ainsi que les retours chariots pour "nettoyer" la ligne.
      Ligne = g_strstrip (Ligne);

      //Recherche des différents coups contenus dans une ligne
      if (g_ascii_strncasecmp (Ligne, "", 1) != 0)	//Ne tient pas compte des lignes vides
	{
	  /* Je mémorise cette ligne avec un ajout d'un espace en fin.
	     Chaque ligne sera ajoutée ainsi les unes après les autres de façon
	     à ne former plus qu'une seule ligne comportant toute la partie.
	     Il sera ainsi plus facile de la traiter pour en extraire les coups.
	   */
	  memo_coup_tmp = g_strdup (memo_coup);
	  g_free (memo_coup);
	  memo_coup = g_strdup_printf ("%s %s", memo_coup_tmp, Ligne);
	  g_free (memo_coup_tmp);
	}
      g_free (Ligne);
    }
  g_free (ligne_tmp1);

  memo_coup = g_strstrip (memo_coup);	// Nettoyage de la ligne

  /* mem_coup contient une ligne de caractère avec tous les coups joués
     On passe maintenant au traitement proprement dit des != coups.

     Il existe 2 types de commentaires dans un fichier pgn. Ceux compris
     entre [] et ceux compris entre {}. La première chose à faire donc
     et de les supprimer.
     Comme certains commentaires entre [] peuvent être imbriqués dans
     des {}, nous commencerons par supprimer les {}.
   */
  while (1)
    {
      if (strstr (memo_coup, "{") != NULL)
	{
	  // On se place sur le { suivant
	  debut_commentaire = strstr (memo_coup, "{");

	  // On cherche maintenant la fin du commentaire
	  if (strstr (memo_coup, "}") != NULL)
	    {
	      Ligne = g_strndup (memo_coup, debut_commentaire - memo_coup);
	      Ligne = g_strstrip (Ligne);	// Nettoyage des espaces de début et fin
	      nouvelle_ligne =
		g_strdup_printf ("%s%s", Ligne, strstr (memo_coup, "}") + 1);
	      g_free (memo_coup);
	      memo_coup = g_strdup (nouvelle_ligne);
	      g_free (nouvelle_ligne);
	      g_free (Ligne);
	    }
	  else
	    break;
	}
      else
	break;
    }

  /* memo_coup a été maintenant nettoyé de tous les commentaires compris entre {}.
     On recommence la même méthode mais cette fois pour les commentaires entre [].
   */
  while (1)
    {
      if (strstr (memo_coup, "[") != NULL)
	{
	  // On se place sur le [ suivant
	  debut_commentaire = strstr (memo_coup, "[");

	  // On cherche maintenant la fin du commentaire
	  if (strstr (memo_coup, "]") != NULL)
	    {
	      Ligne = g_strndup (memo_coup, debut_commentaire - memo_coup);
	      Ligne = g_strstrip (Ligne);	// Nettoyage des espaces de début et fin
	      nouvelle_ligne =
		g_strdup_printf ("%s%s", Ligne, strstr (memo_coup, "]") + 1);
	      g_free (memo_coup);
	      memo_coup = g_strdup (nouvelle_ligne);
	      g_free (nouvelle_ligne);
	      g_free (Ligne);
	    }
	  else
	    break;
	}
      else
	break;
    }
  memo_coup = g_strstrip (memo_coup);	// Nettoyage des espaces de début et de fin

  // On possède maintenant memo_coup qui ne contient plus aucun commentaire.

  //Nous passons à l'extraction proprement dit des coups.
  champs = g_strsplit (memo_coup, " ", 0);	// Séparation dans un tableau de caractère

  // On sépare le coup blanc du numéro de coup s'il n'y a pas d'espace
  for (x = 0; champs[x] != NULL; x++)
    {
      if (strstr (champs[x], "."))
	{
	  if (strlen (champs[x]) > 2)	// Ce champs contient le numéro du coup + le coup blanc attaché.
	    {
	      ligne_tmp1 =
		g_strndup (champs[x] +
			   (strstr (champs[x], ".") - champs[x] + 1),
			   strlen (champs[x]) - 2);
	      g_free (champs[x]);
	      champs[x] = ligne_tmp1;
	    }
	}
    }
  g_free (memo_coup);
  g_free (texte_coup);

  return champs;
}

gboolean chargement_fichier_pgn (gchar * filename, gchar *** contents)
{
  gchar *tmp;
  if (g_file_get_contents (filename, &tmp, NULL, NULL))
    {
      *contents = extraction_coup_dans_fichier (tmp);
      // tmp est libéré dans la fct extraction_coup_dans_fichier();
      return TRUE;
    }
  else
    return FALSE;
}

/* traduit un coup en case échiquier
   Renvoie -1 si aucune traduction possible */
gint recherche_coup_arrive (gchar * coup)
{
  int case_arrivee = -1;

  if (strlen (coup) < 2)
    return case_arrivee;

  if (strlen (coup) == 4)
    coup = coup + 2;
  else if (strlen (coup) == 3)
    coup = coup + 1;

  // Détermination de la case d'arrivée
  if (strncmp (coup, "a", 1) == 0)
    case_arrivee = 1;
  else if (strncmp (coup, "b", 1) == 0)
    case_arrivee = 2;
  else if (strncmp (coup, "c", 1) == 0)
    case_arrivee = 3;
  else if (strncmp (coup, "d", 1) == 0)
    case_arrivee = 4;
  else if (strncmp (coup, "e", 1) == 0)
    case_arrivee = 5;
  else if (strncmp (coup, "f", 1) == 0)
    case_arrivee = 6;
  else if (strncmp (coup, "g", 1) == 0)
    case_arrivee = 7;
  else
    case_arrivee = 8;

  coup++;

  if (strncmp (coup, "8", 1) == 0)
    case_arrivee = case_arrivee + 25;
  else if (strncmp (coup, "7", 1) == 0)
    case_arrivee = case_arrivee + 37;
  else if (strncmp (coup, "6", 1) == 0)
    case_arrivee = case_arrivee + 49;
  else if (strncmp (coup, "5", 1) == 0)
    case_arrivee = case_arrivee + 61;
  else if (strncmp (coup, "4", 1) == 0)
    case_arrivee = case_arrivee + 73;
  else if (strncmp (coup, "3", 1) == 0)
    case_arrivee = case_arrivee + 85;
  else if (strncmp (coup, "2", 1) == 0)
    case_arrivee = case_arrivee + 97;
  else
    case_arrivee = case_arrivee + 109;

  return case_arrivee;
}

type_piece recherche_piece_a_jouer (gchar * coup, int coup_arrive)
{
  type_piece piece_a_jouer;
  int piece_jouee = 0;
  int case_depart = 0;
  register int x, y, z;
  GList *liste = NULL;
  short int deb_compte;
  short int fin_compte;

  // Détermination du type de pièce à jouer
  if (strncmp (coup, "N", 1) == 0)
    piece_jouee = cavalier;
  else if (strncmp (coup, "B", 1) == 0)
    piece_jouee = fou;
  else if (strncmp (coup, "K", 1) == 0)
    piece_jouee = roi;
  else if (strncmp (coup, "R", 1) == 0)
    piece_jouee = tour;
  else if (strncmp (coup, "Q", 1) == 0)
    piece_jouee = dame;
  else
    piece_jouee = pion;

  piece_a_jouer.type = piece_jouee;
  piece_a_jouer.couleur=0;
  piece_a_jouer.ponderation=0;
  piece_a_jouer.place=0;
  piece_a_jouer.nbre_cases_jouables=0;
  piece_a_jouer.deplacement_initial=0;

  if (strlen (coup) == 4)
    {
      coup = coup + 1;		// On se place sur la lettre de départ de la pièce
      // Determination de la case de départ
      if (strncmp (coup, "a", 1) == 0
	  || strncmp (coup, "b", 1) == 0
	  || strncmp (coup, "c", 1) == 0
	  || strncmp (coup, "d", 1) == 0
	  || strncmp (coup, "e", 1) == 0
	  || strncmp (coup, "f", 1) == 0
	  || strncmp (coup, "g", 1) == 0 || strncmp (coup, "h", 1) == 0)
	{
	  if (strncmp (coup, "a", 1) == 0)
	    case_depart = 26;
	  else if (strncmp (coup, "b", 1) == 0)
	    case_depart = 27;
	  else if (strncmp (coup, "c", 1) == 0)
	    case_depart = 28;
	  else if (strncmp (coup, "d", 1) == 0)
	    case_depart = 29;
	  else if (strncmp (coup, "e", 1) == 0)
	    case_depart = 30;
	  else if (strncmp (coup, "f", 1) == 0)
	    case_depart = 31;
	  else if (strncmp (coup, "g", 1) == 0)
	    case_depart = 32;
	  else
	    case_depart = 33;

	  for (x = case_depart; x < case_depart + 96; x = x + 12)
	    {
	      if (echiquier[x].type_piece == piece_jouee
		  && echiquier[x].couleur_piece == humain_joue)
		{
		  // Avec la case de départ il est facile de retrouver la pièce
		  // en utilisant l'enregistrement de l'échiquier.
		  piece_a_jouer = table_piece[echiquier[x].pos_table_piece];
		  x = case_depart + 96;	// Pour sortir de la boucle
		}
	    }
	}
      else
	if (strncmp (coup, "1", 1) == 0
	    || strncmp (coup, "2", 1) == 0
	    || strncmp (coup, "3", 1) == 0
	    || strncmp (coup, "4", 1) == 0
	    || strncmp (coup, "5", 1) == 0
	    || strncmp (coup, "6", 1) == 0
	    || strncmp (coup, "7", 1) == 0 || strncmp (coup, "8", 1) == 0)
	{
	  if (strncmp (coup, "8", 1) == 0)
	    case_depart = 26;
	  else if (strncmp (coup, "7", 1) == 0)
	    case_depart = 38;
	  else if (strncmp (coup, "6", 1) == 0)
	    case_depart = 50;
	  else if (strncmp (coup, "5", 1) == 0)
	    case_depart = 62;
	  else if (strncmp (coup, "4", 1) == 0)
	    case_depart = 74;
	  else if (strncmp (coup, "3", 1) == 0)
	    case_depart = 86;
	  else if (strncmp (coup, "2", 1) == 0)
	    case_depart = 98;
	  else
	    case_depart = 110;

	  for (x = case_depart; x < case_depart + 8; x++)
	    {
	      if (echiquier[x].type_piece == piece_jouee
		  && echiquier[x].couleur_piece == humain_joue)
		{
		  // Avec la case de départ il est facile de retrouver la pièce
		  // en utilisant l'enregistrement de l'échiquier.
		  piece_a_jouer = table_piece[echiquier[x].pos_table_piece];
		  x = case_depart + 8;	// Pour sortir de la boucle
		}
	    }
	}
    }
  else if (strlen (coup) == 3)
    {
      // Il faut trouver la pièce dans tab_piece
      if (humain_joue == noire)
	{
	  deb_compte = 25;
	  fin_compte = 33;
	}
      else
	{
	  deb_compte = 9;
	  fin_compte = 17;
	}

      for (x = deb_compte; x < fin_compte; x++)
	{
	  if (table_piece[x].type == piece_jouee)
	    {
	      // On a trouvé une pièce.
	      // Maintenant il faut chercher si cette pièce peut jouer la case d'arrivée
	      liste = g_list_first (liste_coups_jouables);
	      y = g_list_length (liste);
	      if (y > 0)
		{
		  for (z = 0; z < y; z++)
		    {
		      if (((struct struct_coups_jouables *) (liste->data))->
			  pos_piece_tab == x
			  && ((struct struct_coups_jouables *) (liste->data))->coup ==
			  coup_arrive)
			{
			  piece_a_jouer = table_piece[x];
			  x = fin_compte;	// Pour sortir
			  z = y;
			}
		      liste = g_list_next (liste);
		    }
		}
	    }
	}
    }
  else if (strlen (coup) == 2)
    {
      // Il faut trouver le pion dans tab_piece
      if (humain_joue == noire)
	{
	  deb_compte = 17;
	  fin_compte = 25;
	}
      else
	{
	  deb_compte = 1;
	  fin_compte = 9;
	}

      for (x = deb_compte; x < fin_compte; x++)
	{
	  if (table_piece[x].type == piece_jouee)
	    {
	      // On a trouvé un pion.
	      // Maintenant il faut chercher si cette pièce peut jouer la case d'arrivée
	      liste = g_list_first (liste_coups_jouables);
	      y = g_list_length (liste);
	      if (y > 0)
		{
		  for (z = 0; z < y; z++)
		    {
		      if (((struct struct_coups_jouables *) (liste->data))->
			  pos_piece_tab == x
			  && ((struct struct_coups_jouables *) (liste->data))->coup ==
			  coup_arrive)
			{
			  piece_a_jouer = table_piece[x];
			  x = fin_compte;	// Pour sortir
			  z = y;
			}
		      liste = g_list_next (liste);
		    }
		}
	    }
	}
    }

  return piece_a_jouer;
}

void traduction_insertion_coup (gchar * coup, gpointer data)
{
  struct struct_donnee
  {
    type_piece piece;
    gint case_arrivee;
  };
  struct struct_donnee *donnees_en_retour = (struct struct_donnee *) data;

  gchar *coup_temp = NULL;
  gchar *coup_tempp = NULL;
  gint coup_arrive = 0;
  type_piece piece_a_jouer;
  gint type_deplacement = 0;
  short int promotion;

  promotion = 0;		// Pas de promotion
  piece_a_jouer.type = -1;
  piece_a_jouer.couleur=0;
  piece_a_jouer.ponderation=0;
  piece_a_jouer.place=0;
  piece_a_jouer.nbre_cases_jouables=0;
  piece_a_jouer.deplacement_initial=0;

  //Si le coup est un petit roque
  if (strcmp (coup, "O-O") == 0)
    {
      if (humain_joue == blanc)
	{
	  piece_a_jouer = table_piece[16];
	  coup_arrive = 116;
	}
      else
	{
	  piece_a_jouer = table_piece[32];
	  coup_arrive = 32;
	}
    }
  else
    // Si le coup est un grand roque
  if (strcmp (coup, "O-O-O") == 0)
    {
      if (humain_joue == blanc)
	{
	  piece_a_jouer = table_piece[16];
	  coup_arrive = 112;
	}
      else
	{
	  piece_a_jouer = table_piece[32];
	  coup_arrive = 28;
	}
    }
  else if (strcmp (coup, "1-0") != 0	//Si les blancs ont gagné
	   && strcmp (coup, "0-1") != 0	// Si les noirs ont gagné
	   && strcmp (coup, "1-1") != 0	// Si partie nulle
	   && strcmp (coup, "1/2-1/2") != 0)	// Si partie nulle
    // Recherche du coup
    {
      // Suppression du signe "+" s'il existe
      if (strstr (coup, "+") != NULL)
	{
	  coup_temp = g_strndup (coup, strlen (coup) - 1);
	  g_free (coup);
	  coup = g_strdup (coup_temp);
	  g_free (coup_temp);
	}

      // Suppression du signe "#" s'il existe
      if (strstr (coup, "#") != NULL)
	{
	  coup_temp = g_strndup (coup, strlen (coup) - 1);
	  g_free (coup);
	  coup = g_strdup (coup_temp);
	  g_free (coup_temp);
	}

      // Si le coup est entre autre une promotion
      if (strstr (coup, "=") != NULL)
	{
	  // Détermination du type de promotion
	  coup_tempp = g_strdup (coup);
	  coup_temp = strstr (coup_tempp, "=") + 1;

	  // Détermination du type de pièce à jouer
	  if (strncmp (coup_temp, "N", 1) == 0)
	    promotion = cavalier;
	  else if (strncmp (coup_temp, "B", 1) == 0)
	    promotion = fou;
	  else if (strncmp (coup_temp, "R", 1) == 0)
	    promotion = tour;
	  else if (strncmp (coup_temp, "Q", 1) == 0)
	    promotion = dame;

	  coup_temp = strstr (coup_tempp, "=");
	  g_free (coup);
	  coup = g_strndup (coup_tempp, coup_temp - coup_tempp);
	  g_free (coup_tempp);
	}

      // Si ce n'est pas une prise alors ...
      if (strstr (coup, "x") == NULL)
	{
	  coup_temp = g_strdup (coup);

	  coup_arrive = recherche_coup_arrive (coup_temp);

	  if (coup_arrive != -1)
	    piece_a_jouer = recherche_piece_a_jouer (coup_temp, coup_arrive);
	  g_free (coup_temp);
	}
      else			// C'est une prise
	{
	  // Extraction de la case d'arrivée ( les 2 dernières lettres )
	  coup_tempp = g_strdup (coup);
	  coup_temp = strstr (coup_tempp, "x") + 1;
	  coup_arrive = recherche_coup_arrive (coup_temp);
	  g_free (coup_tempp);

	  // On extrait les caractères allant jusqu'à "x" qui correspondent à la pièce déplacée.
	  coup_temp = g_strndup (coup, strstr (coup, "x") - coup);

	  // Il faut trouver la pièce dans tab_piece
	  piece_a_jouer =
	    recherche_coup_valide (liste_coups_jouables, humain_joue,
				   coup_temp, coup_arrive);
	  g_free (coup_temp);
	}
    }
  else
    coup_arrive = -1;		// Pour ne pas effectuer les fonctions suivantes

  if (coup_arrive != -1 && piece_a_jouer.type != -1)	// Si le coup a pu être traduit
    {
      // MAJ des différentes pièces mises en jeu dans ce déplacement
      // dans les différents tableaux concernés
      type_deplacement =
	deplacer_piece (liste_coups_jouables, piece_a_jouer, coup_arrive);

      // On initialise la structure transmise à la fonction avec les données calculées
      if (donnees_en_retour != NULL)
	{
	  donnees_en_retour->piece = piece_a_jouer;
	  donnees_en_retour->case_arrivee = coup_arrive;
	}

      // Vidange de la liste des coups jouables
      vider_liste (liste_coups_jouables);
      liste_coups_jouables = NULL;

      // calcul des nouveaux coups jouables pour chaque pièce
      liste_coups_jouables = calcul_cases_jouables (liste_coups_jouables);

      // Suppression des coups non jouables suite à clouage.
      if (humain_joue == blanc)
	liste_coups_jouables =
	  elimination_des_coups_cloues (liste_coups_jouables, noir);
      else
	liste_coups_jouables =
	  elimination_des_coups_cloues (liste_coups_jouables, blanc);

      // Affichage du coup joué dans le cadre_partie et sauvegarde de la position
      sauvegarde_position (creation_affich_coups
			   (piece_a_jouer.type, humain_joue,
			    piece_a_jouer.place, coup_arrive,
			    type_deplacement));

      // Incrémentation du nombre de coups joués
      num_coup_joue++;

      if (!gnuchess)
	{
	  if (humain_joue == noire)
	    humain_joue = blanc;
	  else
	    humain_joue = noire;
	}
    }
}

/*Fonction qui traduit une partie du format pgn en un format compréhensible par le jeu.
	Elle peut renvoyer :
	-1 : impossibilité de charger la partie
	0  : la partie est chargée ( pas forcément complètement )*/
int
incorporation_pgn_dans_jeu (gchar * nom_fichier)
{
  gchar *coup = NULL;
  short int x;
  gchar **champs;

  if ((chargement_fichier_pgn (nom_fichier, &champs)))
	{				// Si le fichier à bien été ouvert et lu alors ...
		for (x = 0; champs[x] != NULL; x++)
		{
			if (strstr (champs[x], ".") == NULL
					&& strstr (champs[x], "$") == NULL)
			{	//Si le champ ne comporte pas "." et "$" alors c'est un coup possible
				coup = g_strdup (champs[x]);
				traduction_insertion_coup (coup, NULL);
				// coup est libéré dans la fonction traduction_insertion_coup.
			}
		}
		g_strfreev (champs);	// Libération mémoire du tableau devenu inutile.
		partie_en_cours = TRUE;
		partie_enregistree = TRUE;
		return 0;
	}
  else
    return -1;
}
